//----------------------------------------------------------------------//
// NyanFi																//
//  LtH_/Cu/ݒ/fBNgI					//
//----------------------------------------------------------------------//
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "EditItem.h"
#include "MainFrm.h"
#include "ShareDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNetShareDlg *NetShareDlg;

//---------------------------------------------------------------------------
int __fastcall sort_comp_DirIcon(TStringList *List, int Index1, int Index2)
{
	UnicodeString dnam0 = List->Strings[Index1];
	UnicodeString dnam1 = List->Strings[Index2];
	UnicodeString inam0 = get_FolderIconName(dnam0);
	UnicodeString inam1 = get_FolderIconName(dnam1);
	dnam0 = ExtractFileName(ExcludeTrailingPathDelimiter(dnam0));
	dnam1 = ExtractFileName(ExcludeTrailingPathDelimiter(dnam1));

	if (SameText(inam0, inam1)) return CompNameFN(dnam0, dnam1);
	if (inam0.IsEmpty()) return 1;
	if (inam1.IsEmpty()) return -1;
	return CompNameFN(inam0, inam1);
}

//---------------------------------------------------------------------------
__fastcall TNetShareDlg::TNetShareDlg(TComponent* Owner)
	: TForm(Owner)
{
	rqRetPath = false;
	isShare = isOnlySub = isLibrary = isFindSet = false;
	isPC = isUNC = false;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, ShareListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormShow(TObject *Sender)
{
	isPC = isUNC = false;

	if (isShare)
		IniFile->LoadPosInfo(this, DialogCenter);
	else if (isLibrary)
		IniFile->LoadPosInfo(this, DialogCenter, "Library");
	else if (isFindSet)
		IniFile->LoadPosInfo(this, DialogCenter, "FindSet");
	else
		IniFile->LoadPosInfo(this, DialogCenter, isOnlySub? "SelSub" : "SelDir");

	//
	TControl *cp = (TControl *)((CurListTag==0)? NyanFiForm->L_Panel : NyanFiForm->R_Panel);
	TPoint p = cp->ClientToScreen(cp->ClientRect.CenteredRect(BoundsRect).Location);
	Left = p.x;
	Top  = p.y;

	//͂ݏoC
	cp = (TControl *)NyanFiForm->ListPanel;
	TPoint p0 = cp->ClientToScreen(Point(0, 0));
	TPoint p1 = cp->ClientToScreen(Point(0, cp->Height));
	if (Top < p0.y)			 	Top  = p0.y;
	if ((Top + Height) > p1.y)	Top  = p1.y - Height;
	if (Left < p0.x)			Left = p0.x;

	set_StdListBox(ShareListBox);
	set_UsrScrPanel(ListScrPanel);
	ShareListBox->Clear();

	::PostMessage(Handle, WM_FORM_SHOWED, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::WmFormShowed(TMessage &msg)
{
	PathTabControl->Repaint();

	//LtH_
	if (isShare) {
		if (!ComputerName.IsEmpty() && !StartsStr("\\\\", ComputerName)) ComputerName.Insert("\\\\", 1);
		ComputerName = ExcludeTrailingPathDelimiter(ComputerName);
		PathName     = ComputerName;
		UpdateShareList(ComputerName);
	}
	//Cu
	else if (isLibrary) {
		Caption = "Cu";
		std::unique_ptr<TStringList> l_lst(new TStringList());
		get_files(LibraryPath, "*.library-ms", l_lst.get());
		ShareListBox->Items->Assign(l_lst.get());
		ListBoxSetIndex(ShareListBox, 0);
	}
	//ݒ
	else if (isFindSet) {
		Caption = "ݒ";
		std::unique_ptr<TStringList> l_lst(new TStringList());
		std::unique_ptr<TStringList> s_lst(new TStringList());
		get_files(ExePath, "*.ini", l_lst.get(), true);
		for (int i=0,n=0; i<l_lst->Count; i++) {
			UnicodeString fnam = l_lst->Strings[i];
			std::unique_ptr<UsrIniFile> set_file(new UsrIniFile(fnam));
			UnicodeString sct = "FindSettings";
			if (set_file->SectionExists(sct)) {
				//t@C [TAB] \F [TAB] Xgt@C
				s_lst->Add(fnam + "\t" + set_file->ReadString(sct, "Color") + "\t" + set_file->ReadString(sct, "DirList"));
			}
		}
		s_lst->Sort();
		ShareListBox->Items->Assign(s_lst.get());
		ListBoxSetIndex(ShareListBox, 0);
		FileName = EmptyStr;
	}
	//fBNg̑I
	else {
		PathName = IncludeTrailingPathDelimiter(PathName);
		UpdatePathList(PathName);
	}

	ListScrPanel->UpdateKnob();

	UpdateBreadcrumb(PathName);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (isShare)
		IniFile->SavePosInfo(this);
	else if (isLibrary)
		IniFile->SavePosInfo(this, "Library");
	else if (isFindSet)
		IniFile->SavePosInfo(this, "FindSet");
	else
		IniFile->SavePosInfo(this, isOnlySub? "SelSub" : "SelDir");

	rqRetPath = false;
	isShare = isOnlySub = isLibrary = isFindSet = false;
	isPC  = false;
	Title = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString topic = HELPTOPIC_FL;
	if		(isShare)	topic += "#ShareList";
	else if (isLibrary)	topic += "#Library";
	else if (isFindSet)	topic += "#LoadFindSet";
	else if (rqRetPath)	topic  = EmptyStr;
	else				topic += "#SubDirList";

	if (!topic.IsEmpty())
		SpecialKeyProc(this, Key, Shift, topic.c_str());
	else
		SpecialKeyProc(this, Key, Shift);
}

//---------------------------------------------------------------------------
//LtH_ꗗ̎擾
//---------------------------------------------------------------------------
NET_API_STATUS __fastcall TNetShareDlg::GetShareList(
	UnicodeString cnam,		//\\Rs[^
	TListBox *lp)
{
	lp->Clear();
	static PSHARE_INFO_1 p_si = NULL;
	DWORD entry_cnt, total_cnt;
	cursor_HourGlass();
	NET_API_STATUS res = ::NetShareEnum(cnam.c_str(), 1, (LPBYTE *)&p_si, MAX_PREFERRED_LENGTH, &entry_cnt, &total_cnt, NULL);
	if (res==NERR_Success) {
		for (DWORD i=0; i<entry_cnt; i++) {
			if (p_si[i].shi1_type==STYPE_DISKTREE) {
				UnicodeString nnam = p_si[i].shi1_netname;
				if (!EndsStr("$", nnam)) lp->Items->Add(IncludeTrailingPathDelimiter(cnam) + nnam);
			}
		}
	}
	if (p_si) ::NetApiBufferFree(p_si);
	cursor_Default();
	return res;
}
//---------------------------------------------------------------------------
//LtH_ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::UpdateShareList(
	UnicodeString cnam)	//\\Rs[^
{
	cnam = ExcludeTrailingPathDelimiter(cnam);
	Caption = yen_to_delimiter(cnam) + " - LtH_ꗗ";

	TListBox *lp = ShareListBox;
	NET_API_STATUS res = GetShareList(cnam, lp);
	if (res!=NERR_Success) {
		//Rs[^ɐڑ
		NETRESOURCEW nr = {};
		nr.dwType		= RESOURCETYPE_ANY;
		nr.lpRemoteName = (LPWSTR)cnam.c_str();
		DWORD n_res = WNetAddConnection3W(this->Handle, &nr, NULL, NULL, CONNECT_INTERACTIVE);
		if (n_res==NO_ERROR) {
			res = GetShareList(cnam, lp);
		}
		else if (n_res==ERROR_CANCELLED) {
			Close();
			return;
		}
	}
	if (res!=NERR_Success) {
		beep_Warn();
		Caption = Caption + " - " + SysErrorMessage(res);
	}
	ListScrPanel->UpdateKnob();

	ListBoxSetIndex(lp, lp->Items->IndexOf(ExcludeTrailingPathDelimiter(CurPathName)));
}

//---------------------------------------------------------------------------
//fBNgꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::UpdatePathList(
	UnicodeString pnam)	//fBNg (EmptyStr ȂhCuI)
{
	Caption = (!Title.IsEmpty()? (Title + " - ") : EmptyStr) +
				(pnam.IsEmpty()? UnicodeString("PC") : yen_to_delimiter(ExcludeTrailingPathDelimiter(pnam))) ;

	cursor_HourGlass();
	LibIdxBase = -1;
	std::unique_ptr<TStringList> d_lst(new TStringList());
	//hCu
	if (pnam.IsEmpty()) {
		isPC = true;
		for (int i=0; i<DriveInfoList->Count; i++) {
			drive_info *dp = (drive_info *)DriveInfoList->Objects[i];
			if (!dp->accessible) continue;
			d_lst->Add(UnicodeString().sprintf(_T("%s %s"), get_tkn(dp->drive_str, '\\').c_str(), dp->volume.c_str()));
		}
		//Cu
		std::unique_ptr<TStringList> l_lst(new TStringList());
		get_files(LibraryPath, "*.library-ms", l_lst.get());
		if (l_lst->Count>0) {
			d_lst->Add("-");
			LibIdxBase = d_lst->Count;
			d_lst->AddStrings(l_lst.get());
		}
		else {
			LibIdxBase = d_lst->Count;
		}
	}
	//fBNg
	else {
		isPC = false;
		pnam = IncludeTrailingPathDelimiter(pnam);
		TSearchRec sr;
		if (FindFirst(cv_ex_filename(pnam + "*"), faAnyFile, sr)==0) {
			do {
				if ((sr.Attr & faDirectory)==0) continue;
				if (!ShowHideAtr   && (sr.Attr & faHidden))  continue;
				if (!ShowSystemAtr && (sr.Attr & faSysFile)) continue;
				if (ContainsStr("..", sr.Name)) continue;
				d_lst->AddObject(pnam + sr.Name, (TObject*)(NativeInt)sr.Attr);
			} while(FindNext(sr)==0);
			FindClose(sr);
		}
		d_lst->CustomSort((DirSortMode[CurListTag]==6)? sort_comp_DirIcon : comp_NaturalOrder);
		if (!is_root_dir(pnam) && isOnlySub) d_lst->Insert(0, pnam + "..");
	}
	TListBox *lp = ShareListBox;
	lp->Items->Assign(d_lst.get());
	ListScrPanel->UpdateKnob();

	int idx = -1;
	for (int i=0; i<lp->Count && idx==-1; i++) {
		UnicodeString lbuf = lp->Items->Strings[i];
		if (pnam.IsEmpty()) lbuf = get_tkn(lbuf, ' ');
		if (StartsStr(IncludeTrailingPathDelimiter(lbuf), IncludeTrailingPathDelimiter(CurPathName))) idx = i;
	}
	ListBoxSetIndex(lp, idx);
	cursor_Default();
}
//---------------------------------------------------------------------------
//pXg̍XV
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::UpdateBreadcrumb(UnicodeString pnam)
{
	OutDebugStr(pnam);
	PathTabControl->Visible = false;
	PathTabControl->Height = get_FontHeightMgnS(PathTabControl->Font, 6, 6) + SCALED_THIS(2);
	PathTabControl->Tabs->Clear();
	isUNC = false;
	if (!isOnlySub && !isFindSet && !isLibrary) {
		isUNC = StartsStr("\\\\", pnam);
		if (!isUNC) PathTabControl->Tabs->Add("PC");
		TStringDynArray plst = split_path(pnam);
		for (int i=0; i<plst.Length; i++) PathTabControl->Tabs->Add(plst[i] + " >");
		PathTabControl->Visible  = true;
		PathTabControl->TabIndex = PathTabControl->Tabs->Count - 1;
	}
}
//---------------------------------------------------------------------------
//pXg̏
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PathTabControlDrawTab(TCustomTabControl *Control, int TabIndex,
	const TRect &Rect, bool Active)
{
	TTabControl *tp = (TTabControl*)Control;
	TCanvas *cv = tp->Canvas;
	cv->Brush->Color = Active? col_bgOptTab : get_PanelColor();
	cv->Font->Color  = Active? col_fgOptTab : get_LabelColor();
	cv->FillRect(Rect);

	int yp = (Rect.Height() - cv->TextHeight("Q")) /2;
	int xp = Rect.Left + SCALED_THIS(4);
	UnicodeString s = get_tkn(PathTabControl->Tabs->Strings[TabIndex], " >");
	bool is_dir = (TabIndex>0 || StartsStr("\\\\", s));
	s = ReplaceStr(s, "\\", " ");
	cv->TextOut(xp, yp, s);
	if (is_dir) {
		xp += cv->TextWidth(s);
		cv->Brush->Style = bsClear;
		cv->Font->Color  = AdjustColor(get_LabelColor(), ADJCOL_LIGHT);
		cv->TextOut(xp, yp, " >");
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PathTabControlChange(TObject *Sender)
{
	int idx = PathTabControl->TabIndex;
	if (idx!=-1) {
		UnicodeString pnam = GetBreadcrumbStr(idx);
		if (is_computer_name(pnam)) {
			ComputerName = ExcludeTrailingPathDelimiter(pnam);
			UpdateShareList(ComputerName);
		}
		else {
			UpdatePathList(pnam);
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ListPanelResize(TObject *Sender)
{
	ShareListBox->Invalidate();
}

//---------------------------------------------------------------------------
//Xgڂ̕`
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(ListFont);
	cv->Brush->Color = get_ListBgCol();
	cv->FillRect(Rect);

	UnicodeString lbuf = lp->Items->Strings[Index];
	if (SameStr(lbuf, "-")) {
		draw_Separator(cv, Rect, get_ListBgCol());
	}
	else {
		int xp = Rect.Left + SCALED_THIS(2);
		int yp = Rect.Top  + get_TopMargin2(cv);

		//ANZXL[
		cv->Font->Color = get_ListFgCol();
		cv->Font->Style = cv->Font->Style << fsUnderline;
		if (isPC) {
			if (Index<LibIdxBase) {
				cv->TextOut(xp, yp, lbuf.SubString(1, 1));
			}
			else {
				int idx = Index - LibIdxBase;
				if (idx<10) cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), (idx + 1)%10));
			}
		}
		else if (Index<10) {
			cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), (Index + 1)%10));
		}

		cv->Font->Style = cv->Font->Style >> fsUnderline;
		xp += get_CharWidth(cv, 2);

		//Cu
		if (isLibrary || (isPC && Index>=LibIdxBase)) {
			draw_SmallIcon2(lbuf, cv, xp, std::max(yp + (cv->TextHeight("Q") - SCALED_THIS(16))/2, 0), this);
			xp += SCALED_THIS(20);
			cv->Font->Color = col_Folder;
			cv->TextOut(xp, yp, get_base_name(lbuf));
		}
		//ݒ
		else if (isFindSet) {
			TStringDynArray itm_buf = split_strings_tab(lbuf);
			cv->Font->Color = TColor(get_array_item(itm_buf, 1).ToIntDef((int)col_Folder));
			cv->TextOut(xp, yp, get_base_name(get_array_item(itm_buf, 0)));
		}
		//hCu
		else if (isPC) {
			drive_info *dp = get_DriveInfo(lbuf);
			if (dp) {
				TIcon *ip = dp->small_ico;
				if (ip && ip->Handle) {
					::DrawIconEx(cv->Handle, xp, yp + 1, ip->Handle,
									SCALED_THIS(16), SCALED_THIS(16), 0, NULL, DI_NORMAL);
				}
			}
			xp += SCALED_THIS(20);
			cv->Font->Color = get_ListFgCol();
			cv->TextOut(xp, yp, get_tkn_r(lbuf, ' '));
		}
		//fBNgȂ
		else {
			if (IconMode==1 || IconMode==2) {
				HICON hIcon = get_folder_icon(lbuf);
				if (hIcon) {
					::DrawIconEx(cv->Handle, xp, yp + 1, hIcon,
									SCALED_THIS(16), SCALED_THIS(16), 0, NULL, DI_NORMAL);
				}
				xp += SCALED_THIS(20);
			}
			int attr = (int)lp->Items->Objects[Index];
			cv->Font->Color =
				(attr & faSysFile) ? col_System :
				(attr & faHidden)  ? col_Hidden :
				(attr & faReadOnly)? col_ReadOnly :
				(attr & faSymLink) ? col_SymLink : col_Folder;
			cv->TextOut(xp, yp, ExtractFileName(lbuf));
			xp += cv->TextWidth(ExtractFileName(lbuf));
		}

		//fBNg̃^CX^v
		if (!isPC && !isLibrary && !isFindSet) {
			TDateTime dt = get_file_age(lbuf);
			if (dt!=(TDateTime)0) {
				UnicodeString s = get_TimeStampStr(dt);
				int x_t = ListPanel->ClientWidth - cv->TextWidth(s + "X");
				x_t -= ((ScrBarStyle>0)? ListScrPanel->KnobWidth : get_SysMetricsForPPI(SM_CXVSCROLL, CurrentPPI));
				if (x_t > xp) {
					cv->Font->Color = get_TimeColor(dt, get_ListFgCol());
					cv->TextOut(x_t, yp, s);
				} 
			}
		}
	}

	//J[\
	draw_ListCursor(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = (TListBox*)Sender;
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);

	//hCum
	UnicodeString dstr;
	if (isPC && (equal_ENTER(KeyStr) || (!KeyStr.IsEmpty() && isalpha(KeyStr[1])))) {
		if (equal_ENTER(KeyStr)) {
			int idx = lp->ItemIndex;
			if (idx!=-1 && idx<LibIdxBase-1) dstr = IncludeTrailingPathDelimiter(get_tkn(lp->Items->Strings[idx], ' '));
		}
		else {
			for (int i=0; i<LibIdxBase; i++) {
				if (StartsText(KeyStr, lp->Items->Strings[i])) {
					dstr.sprintf(_T("%c:\\"), KeyStr[1]);
					break;
				}
			}
		}
	}
	if (!dstr.IsEmpty()) {
		if (is_drive_accessible(dstr)) {
			NyanFiForm->RecoverFileList();
			NyanFiForm->UpdateCurDrive(dstr);
			ModalResult = mrOk;
		}
		else {
			beep_Warn();
		}
		Key = 0;
		return;
	}

	//m
	bool handled = true;
	if (is_Num0to9(KeyStr) || equal_ENTER(KeyStr)) {
		int idx;
		if (is_Num0to9(KeyStr)) {
			idx = (KeyStr.ToIntDef(0) + 9)%10;
			if (isPC) idx += LibIdxBase;
		}
		else {
			idx = lp->ItemIndex;
		}

		if (idx!=-1) {
			UnicodeString lbuf = lp->Items->Strings[idx];
			if (!SameStr(lbuf, "-")) {
				//Cu
				if (isLibrary || (isPC && idx>=LibIdxBase)) {
					NyanFiForm->PopSelLibrary(lbuf, CurListTag, lp);
				}
				//ݒ
				else if (isFindSet) {
					FileName = get_pre_tab(lp->Items->Strings[idx]);
				}
				//fBNgAL
				else {
					UnicodeString pnam = GetListPathName(idx);
					if (rqRetPath) {
						PathName = pnam;
					}
					else {
						cursor_HourGlass();
						NyanFiForm->UpdateCurPath(pnam);
						cursor_Default();
					}
				}
				ModalResult = mrOk;
			}
		}
	}
	//pXgi
	else if (PathTabControl->Visible && is_ToRightOpe(KeyStr, cmd_F)) {
		int p_idx = PathTabControl->TabIndex;
		int idx = lp->ItemIndex;
		UnicodeString s = (idx!=-1)? lp->Items->Strings[idx] : EmptyStr;
		if (EndsText(".library-ms", s) || s=="-") s = EmptyStr;
		if (!s.IsEmpty()) {
			if (p_idx==PathTabControl->Tabs->Count-1) {
				UpdateBreadcrumb(GetListPathName(idx));
				PathTabControlChange(PathTabControl);
			}
			else {
				PathTabControl->TabIndex = p_idx + 1;
				PathTabControlChange(PathTabControl);
				if (PathTabControl->TabIndex<PathTabControl->Tabs->Count - 1) {
					UnicodeString pnam = GetBreadcrumbStr(PathTabControl->TabIndex + 1);
					lp->ItemIndex = lp->Items->IndexOf(ExcludeTrailingPathDelimiter(pnam));
				}
			}
		}
	}
	//pXg߂
	else if (PathTabControl->Visible && (is_ToLeftOpe(KeyStr, cmd_F) || SameText(get_CmdStr(cmd_F), "ToParent"))) {
		int p_idx = PathTabControl->TabIndex;
		if (p_idx>0) {
			UnicodeString pnam = GetBreadcrumbStr(p_idx);
			PathTabControl->TabIndex = p_idx -1;
			PathTabControlChange(PathTabControl);
			pnam = ExcludeTrailingPathDelimiter(pnam);
			if (PathTabControl->TabIndex==0) {
				for (int i=0; i<lp->Count; i++) {
					if (SameText(get_tkn(lp->Items->Strings[i], ' '), pnam)) {
						lp->ItemIndex = i;
						break;
					}
				}
			}
			else {
				lp->ItemIndex = lp->Items->IndexOf(ExcludeTrailingPathDelimiter(pnam));
			}
		}
	}
	//|bvAbvj[
	else if (contained_wd_i(KeysStr_Popup, KeyStr)) {
		show_PopupMenu(lp);
	}
	//J[\ړ
	else if	(ExeCmdListBox(lp, cmd_F)) {
		if (PathTabControl->TabIndex<PathTabControl->Tabs->Count-1) {
			int n = PathTabControl->Tabs->Count - PathTabControl->TabIndex - 1;
			for (int i=0; i<n; i++) PathTabControl->Tabs->Delete(PathTabControl->Tabs->Count - 1);
		}
	}
	//T[`
	else if ((isOnlySub || PathTabControl->Visible) && is_IniSeaKey(KeyStr)) {
		ListBoxInitialSearch(lp, KeyStr, true);
	}
	//Rs[
	else if (SameText(KeyStr, KeyStr_Copy) || SameText(cmd_F, "CopyFileName")) {
		UnicodeString lbuf = ListBoxGetStr(lp);
		if (!lbuf.IsEmpty()) {
			if (isPC) lbuf = IncludeTrailingPathDelimiter(get_tkn(lbuf, ' '));
			copy_to_Clipboard(lbuf);
		}
	}
	//vpeB
	else if (SameText(cmd_F, "PropertyDlg")) {
		PropertyAction->Execute();
	}
	//
	else if (SameText(cmd_F, "ReturnList")) {
		ModalResult = mrCancel;
	}
	else {
		handled = false;
	}

	if (!is_DialogKey(Key) || handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key)) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxClick(TObject *Sender)
{
	if (PathTabControl->TabIndex<PathTabControl->Tabs->Count-1) {
		int n = PathTabControl->Tabs->Count - PathTabControl->TabIndex - 1;
		for (int i=0; i<n; i++) PathTabControl->Tabs->Delete(PathTabControl->Tabs->Count - 1);
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::ShareListBoxDblClick(TObject *Sender)
{
	perform_Key_RETURN((TControl*)Sender);
}

//---------------------------------------------------------------------------
//UNCpXRs[
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncActionExecute(TObject *Sender)
{
	copy_to_Clipboard(ListBoxGetStr(ShareListBox));
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isUNC;
	ap->Enabled = ap->Visible && (ShareListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//ׂĂUNCpXRs[
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncAllActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	std::unique_ptr<TStringList> lst(new TStringList());
	for (int i=0; i<lp->Count; i++) {
		lst->Add(IncludeTrailingPathDelimiter(ComputerName) + lp->Items->Strings[i]);
	}
	copy_to_Clipboard(lst->Text);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyUncAllActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isUNC;
	ap->Enabled = ap->Visible && (ShareListBox->Count>0);
}
//---------------------------------------------------------------------------
//fBNgEpXRs[
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyPathActionExecute(TObject *Sender)
{
	UnicodeString lbuf = ListBoxGetStr(ShareListBox);
	if (!lbuf.IsEmpty()) {
		if (isPC) lbuf = IncludeTrailingPathDelimiter(get_tkn(lbuf, ' '));
		copy_to_Clipboard(lbuf);
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyPathActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isOnlySub || (PathTabControl->Visible && !isUNC);
	ap->Enabled = ap->Visible && (ShareListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//ׂẴfBNgEpXRs[
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyPathAllActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	std::unique_ptr<TStringList> lst(new TStringList());
	bool is_drv = isPC;
	for (int i=0; i<lp->Count; i++) {
		UnicodeString lbuf = lp->Items->Strings[i];
		if (is_drv && is_separator(lbuf)) is_drv = false;
		if (is_drv) lbuf = IncludeTrailingPathDelimiter(get_tkn(lbuf, ' '));
		lst->Add(lbuf);
	}
	copy_to_Clipboard(lst->Text);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::CopyPathAllActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isOnlySub || (PathTabControl->Visible && !isUNC);
	ap->Enabled = ap->Visible && (ShareListBox->Count>0);
}
//---------------------------------------------------------------------------
//\F̐ݒ
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::SetColorActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		TStringDynArray itm_buf = split_strings_tab(lp->Items->Strings[idx]);
		UnicodeString fnam = get_array_item(itm_buf, 0);
		UnicodeString col  = get_array_item(itm_buf, 1);
		UserModule->ColorDlg->Color = !col.IsEmpty()? TColor(col.ToIntDef((int)col_Folder)) : col_Folder;
		if (UserModule->ColorDlg->Execute()) {
			col = IntToStr((int)UserModule->ColorDlg->Color);
			std::unique_ptr<UsrIniFile> set_file(new UsrIniFile(fnam));
			UnicodeString sct = "FindSettings";
			set_file->WriteString(sct, "Color", col);
			set_file->UpdateFile(true);
			lp->Items->Strings[idx] = fnam + "\t" + col + "\t" + set_file->ReadString(sct, "DirList");
			lp->Repaint();
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::SetColorActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isFindSet;
	ap->Enabled = ap->Visible && (ShareListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//Xgt@C̕ҏW
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::EditListActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	if (lp->ItemIndex!=-1) {
		if (!open_by_TextEditor(get_tsv_item(ListBoxGetStr(lp), 2))) msgbox_ERR(GlobalErrMsg);
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::EditListActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isFindSet;
	ap->Enabled = (ap->Visible && !get_tsv_item(ListBoxGetStr(ShareListBox), 2).IsEmpty());
}
//---------------------------------------------------------------------------
//OfBNg̐ݒ
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::SetSkipDirActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		std::unique_ptr<UsrIniFile> set_file(new UsrIniFile(get_tsv_item(lp->Items->Strings[idx], 0)));
		UnicodeString sct = "FindSettings";
		if (!EditItemDlg) EditItemDlg = new TEditItemDlg(this);	//ɓI쐬
		EditItemDlg->AssignText("OfBNg", set_file->ReadString(sct, "SkipDir"));
		if (show_ModalDlg(EditItemDlg)==mrOk) {
			set_file->WriteString(sct, "SkipDir", EditItemDlg->RetStr);
			set_file->UpdateFile(true);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::SetSkipDirActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isFindSet;
	ap->Enabled = ap->Visible && (ShareListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//vpeB
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PropertyActionExecute(TObject *Sender)
{
	TListBox *lp = ShareListBox;
	if (lp->ItemIndex!=-1) ShowPropertyDialog(lp->Items->Strings[lp->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TNetShareDlg::PropertyActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = isOnlySub || PathTabControl->Visible;
	ap->Enabled = ap->Visible && (ShareListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
